package javax.lang.model.util;

import javax.lang.model.element.UnknownElementException;
import javax.lang.model.element.Element;
import javax.lang.model.SourceVersion;
import javax.annotation.processing.SupportedSourceVersion;
import javax.lang.model.element.ElementVisitor;

@SupportedSourceVersion(SourceVersion.RELEASE_6)
public abstract class AbstractElementVisitor6<R, P> implements ElementVisitor<R, P>
{
    protected AbstractElementVisitor6() {
    }
    
    @Override
    public final R visit(Element element, P p2) {
        return element.accept(this, p2);
    }
    
    @Override
    public final R visit(Element element) {
        return element.accept(this, null);
    }
    
    @Override
    public R visitUnknown(Element e, P p2) {
        throw new UnknownElementException(e, p2);
    }
}
